FriendXPBar = LibStub("AceAddon-3.0"):NewAddon("FriendXPBar","AceConsole-3.0","AceEvent-3.0","AceComm-3.0","AceSerializer-3.0");

FriendXPBarUserXP = {};
FriendXPBarUserXPMax = {};


local UPDATEPERIOD, elapsed = 0.5, 0
local FriendXPBarLDB = LibStub:GetLibrary("LibDataBroker-1.1")
local FriendXPBarDataObj = FriendXPBarLDB:NewDataObject("Friend XP", {type = "data source", text = "0XP (0%)"})
local f = CreateFrame("frame")

function FriendXPBar:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
  self.db = LibStub("AceDB-3.0"):New("FriendXPBarDB");
 end

function FriendXPBar:OnEnable()
end

function FriendXPBar:OnDisable()
end

function FriendXPBar:GetTarget(info)
	return self.db.char.playerName;
end

function FriendXPBar:SetTarget(info, newValue)
	self.db.char.playerName = newValue;
end

function FriendXPBar:DisplayInfo(info)
	FriendXPBar:Print("Hello");
	FriendXPBar:Print(self.db.char.playerName);
end

function FriendXPBar:CHAT_MSG_ADDON(eventName, ...)
end

function FriendXPBar:CHAT_MSG_COMBAT_XP_GAIN(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:PLAYER_ENTERING_WORLD(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:GROUP_ROSTER_UPDATE(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:PLAYER_LEVEL_UP(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:PLAYER_XP_UPDATE(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:ZONE_CHANGED(eventName, ...)
	FriendXPBar:SetOwnXP();
end

function FriendXPBar:SetOwnXP()
	--Get the players XP and send it over the wire to any listening addons
	local xp = UnitXP("player");
	local xpMax = UnitXPMax("player");
	if( xp ~= nil ) then
		FriendXPBar:SendCommMessage("FRIENDXPBAR_XP",tostring(xp),"PARTY");
	end
	
	if (xpMax ~= nil) then
		FriendXPBar:SendCommMessage("FXP_XPMAX",tostring(xpMax),"PARTY");
	end
	
	FriendXPBarDataObj.text = string.format("%iXP Left (%i %%)", floor(xpMax-xp), 100-floor( (xp/xpMax)*100 ) );
	
	
end

function FriendXPBar:OnCommReceived(prefix, message, distribution, sender)
   --Update the stats based on incoming information
   if(prefix == "FRIENDXPBAR_XP") then
   	FriendXPBarUserXP[sender] = tonumber(message);
   elseif (prefix == "FXP_XPMAX") then
    FriendXPBarUserXPMax[sender] = tonumber(message);
   end
end

--Register all events needed
FriendXPBar:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
FriendXPBar:RegisterEvent("PLAYER_ENTERING_WORLD");
FriendXPBar:RegisterEvent("GROUP_ROSTER_UPDATE");
FriendXPBar:RegisterEvent("PLAYER_LEVEL_UP");
FriendXPBar:RegisterEvent("PLAYER_XP_UPDATE");
FriendXPBar:RegisterEvent("ZONE_CHANGED");

FriendXPBar:RegisterComm("FRIENDXPBAR_XP");
FriendXPBar:RegisterComm("FXP_XPMAX");


function FriendXPBarDataObj:OnTooltipShow()
    self:AddLine("XP To Level")
    
    for name, line in pairsByKeys(FriendXPBarUserXPMax) do
    	--self:AddLine(name .. xpMax);
    	xp = tonumber(FriendXPBarUserXP[name]);
      xpMax = tonumber(FriendXPBarUserXPMax[name]);
      self:AddLine( string.format("%s %iXP Left (%i %%)",name,floor(xpMax-xp), 100-floor( (xp/xpMax)*100 ) ) );
    end

end

function FriendXPBarDataObj:OnEnter()
    GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
    GameTooltip:ClearLines()
    FriendXPBarDataObj.OnTooltipShow(GameTooltip)
    GameTooltip:Show()
end

function FriendXPBarDataObj:OnLeave()
    GameTooltip:Hide()
end

function pairsByKeys (t, f)
      local a = {}
      for n in pairs(t) do table.insert(a, n) end
      table.sort(a, f)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
      end
      return iter
    end
